import { NgtCommonHelper, coerceNumberProperty, provideNgtCommonHelper, provideCommonHelperRef, NgtCommonObjectHelper, provideNgtCommonObjectHelper, provideCommonObjectHelperRef } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule, Directive } from '@angular/core';
import * as THREE from 'three';

// GENERATED
class NgtArrowHelper extends NgtCommonHelper {
    set dir(dir) {
        this.set({ dir });
    }
    set origin(origin) {
        this.set({ origin });
    }
    set length(length) {
        this.set({ length: coerceNumberProperty(length) });
    }
    set headLength(headLength) {
        this.set({ headLength: coerceNumberProperty(headLength) });
    }
    set headWidth(headWidth) {
        this.set({ headWidth: coerceNumberProperty(headWidth) });
    }
    get helperType() {
        return THREE.ArrowHelper;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { dir: true, origin: true, length: true, headLength: true, headWidth: true });
    }
}
NgtArrowHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrowHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtArrowHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtArrowHelper, isStandalone: true, selector: "ngt-arrow-helper", inputs: { dir: "dir", origin: "origin", length: "length", headLength: "headLength", headWidth: "headWidth" }, providers: [provideNgtCommonHelper(NgtArrowHelper), provideCommonHelperRef(NgtArrowHelper)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrowHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-arrow-helper',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonHelper(NgtArrowHelper), provideCommonHelperRef(NgtArrowHelper)],
                }]
        }], propDecorators: { dir: [{
                type: Input
            }], origin: [{
                type: Input
            }], length: [{
                type: Input
            }], headLength: [{
                type: Input
            }], headWidth: [{
                type: Input
            }] } });
class NgtArrowHelperModule {
}
NgtArrowHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrowHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtArrowHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtArrowHelperModule, imports: [NgtArrowHelper], exports: [NgtArrowHelper] });
NgtArrowHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrowHelperModule, imports: [NgtArrowHelper] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrowHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtArrowHelper],
                    exports: [NgtArrowHelper],
                }]
        }] });

// GENERATED
class NgtAxesHelper extends NgtCommonHelper {
    set size(size) {
        this.set({ size: coerceNumberProperty(size) });
    }
    get helperType() {
        return THREE.AxesHelper;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { size: true });
    }
}
NgtAxesHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAxesHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtAxesHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtAxesHelper, isStandalone: true, selector: "ngt-axes-helper", inputs: { size: "size" }, providers: [provideNgtCommonHelper(NgtAxesHelper), provideCommonHelperRef(NgtAxesHelper)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAxesHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-axes-helper',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonHelper(NgtAxesHelper), provideCommonHelperRef(NgtAxesHelper)],
                }]
        }], propDecorators: { size: [{
                type: Input
            }] } });
class NgtAxesHelperModule {
}
NgtAxesHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAxesHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAxesHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtAxesHelperModule, imports: [NgtAxesHelper], exports: [NgtAxesHelper] });
NgtAxesHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAxesHelperModule, imports: [NgtAxesHelper] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAxesHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtAxesHelper],
                    exports: [NgtAxesHelper],
                }]
        }] });

// GENERATED
class NgtGridHelper extends NgtCommonHelper {
    set size(size) {
        this.set({ size: coerceNumberProperty(size) });
    }
    set divisions(divisions) {
        this.set({ divisions: coerceNumberProperty(divisions) });
    }
    set color1(color1) {
        this.set({ color1 });
    }
    set color2(color2) {
        this.set({ color2 });
    }
    get helperType() {
        return THREE.GridHelper;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { size: true, divisions: true, color1: true, color2: true });
    }
}
NgtGridHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtGridHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtGridHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtGridHelper, isStandalone: true, selector: "ngt-grid-helper", inputs: { size: "size", divisions: "divisions", color1: "color1", color2: "color2" }, providers: [provideNgtCommonHelper(NgtGridHelper), provideCommonHelperRef(NgtGridHelper)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtGridHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-grid-helper',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonHelper(NgtGridHelper), provideCommonHelperRef(NgtGridHelper)],
                }]
        }], propDecorators: { size: [{
                type: Input
            }], divisions: [{
                type: Input
            }], color1: [{
                type: Input
            }], color2: [{
                type: Input
            }] } });
class NgtGridHelperModule {
}
NgtGridHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtGridHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtGridHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtGridHelperModule, imports: [NgtGridHelper], exports: [NgtGridHelper] });
NgtGridHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtGridHelperModule, imports: [NgtGridHelper] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtGridHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtGridHelper],
                    exports: [NgtGridHelper],
                }]
        }] });

// GENERATED
class NgtPolarGridHelper extends NgtCommonHelper {
    set radius(radius) {
        this.set({ radius: coerceNumberProperty(radius) });
    }
    set radials(radials) {
        this.set({ radials: coerceNumberProperty(radials) });
    }
    set circles(circles) {
        this.set({ circles: coerceNumberProperty(circles) });
    }
    set divisions(divisions) {
        this.set({ divisions: coerceNumberProperty(divisions) });
    }
    set color1(color1) {
        this.set({ color1 });
    }
    set color2(color2) {
        this.set({ color2 });
    }
    get helperType() {
        return THREE.PolarGridHelper;
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { radius: true, radials: true, circles: true, divisions: true, color1: true, color2: true });
    }
}
NgtPolarGridHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPolarGridHelper, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtPolarGridHelper.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtPolarGridHelper, isStandalone: true, selector: "ngt-polar-grid-helper", inputs: { radius: "radius", radials: "radials", circles: "circles", divisions: "divisions", color1: "color1", color2: "color2" }, providers: [provideNgtCommonHelper(NgtPolarGridHelper), provideCommonHelperRef(NgtPolarGridHelper)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPolarGridHelper, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-polar-grid-helper',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonHelper(NgtPolarGridHelper), provideCommonHelperRef(NgtPolarGridHelper)],
                }]
        }], propDecorators: { radius: [{
                type: Input
            }], radials: [{
                type: Input
            }], circles: [{
                type: Input
            }], divisions: [{
                type: Input
            }], color1: [{
                type: Input
            }], color2: [{
                type: Input
            }] } });
class NgtPolarGridHelperModule {
}
NgtPolarGridHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPolarGridHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPolarGridHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtPolarGridHelperModule, imports: [NgtPolarGridHelper], exports: [NgtPolarGridHelper] });
NgtPolarGridHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPolarGridHelperModule, imports: [NgtPolarGridHelper] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPolarGridHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtPolarGridHelper],
                    exports: [NgtPolarGridHelper],
                }]
        }] });

// GENERATED
class NgtBoxHelper extends NgtCommonObjectHelper {
    set ngtBoxHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.BoxHelper;
    }
}
NgtBoxHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBoxHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtBoxHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtBoxHelper, isStandalone: true, selector: "[ngtBoxHelper]", inputs: { ngtBoxHelper: "ngtBoxHelper" }, providers: [provideNgtCommonObjectHelper(NgtBoxHelper), provideCommonObjectHelperRef(NgtBoxHelper)], exportAs: ["ngtBoxHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBoxHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtBoxHelper]',
                    standalone: true,
                    exportAs: 'ngtBoxHelper',
                    providers: [provideNgtCommonObjectHelper(NgtBoxHelper), provideCommonObjectHelperRef(NgtBoxHelper)],
                }]
        }], propDecorators: { ngtBoxHelper: [{
                type: Input
            }] } });
class NgtBoxHelperModule {
}
NgtBoxHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBoxHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtBoxHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtBoxHelperModule, imports: [NgtBoxHelper], exports: [NgtBoxHelper] });
NgtBoxHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBoxHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBoxHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtBoxHelper],
                    exports: [NgtBoxHelper],
                }]
        }] });

// GENERATED
class NgtBox3Helper extends NgtCommonObjectHelper {
    set ngtBox3Helper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.Box3Helper;
    }
}
NgtBox3Helper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBox3Helper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtBox3Helper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtBox3Helper, isStandalone: true, selector: "[ngtBox3Helper]", inputs: { ngtBox3Helper: "ngtBox3Helper" }, providers: [provideNgtCommonObjectHelper(NgtBox3Helper), provideCommonObjectHelperRef(NgtBox3Helper)], exportAs: ["ngtBox3Helper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBox3Helper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtBox3Helper]',
                    standalone: true,
                    exportAs: 'ngtBox3Helper',
                    providers: [provideNgtCommonObjectHelper(NgtBox3Helper), provideCommonObjectHelperRef(NgtBox3Helper)],
                }]
        }], propDecorators: { ngtBox3Helper: [{
                type: Input
            }] } });
class NgtBox3HelperModule {
}
NgtBox3HelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBox3HelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtBox3HelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtBox3HelperModule, imports: [NgtBox3Helper], exports: [NgtBox3Helper] });
NgtBox3HelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBox3HelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBox3HelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtBox3Helper],
                    exports: [NgtBox3Helper],
                }]
        }] });

// GENERATED
class NgtCameraHelper extends NgtCommonObjectHelper {
    set ngtCameraHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.CameraHelper;
    }
}
NgtCameraHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCameraHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtCameraHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtCameraHelper, isStandalone: true, selector: "[ngtCameraHelper]", inputs: { ngtCameraHelper: "ngtCameraHelper" }, providers: [provideNgtCommonObjectHelper(NgtCameraHelper), provideCommonObjectHelperRef(NgtCameraHelper)], exportAs: ["ngtCameraHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCameraHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtCameraHelper]',
                    standalone: true,
                    exportAs: 'ngtCameraHelper',
                    providers: [provideNgtCommonObjectHelper(NgtCameraHelper), provideCommonObjectHelperRef(NgtCameraHelper)],
                }]
        }], propDecorators: { ngtCameraHelper: [{
                type: Input
            }] } });
class NgtCameraHelperModule {
}
NgtCameraHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCameraHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtCameraHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtCameraHelperModule, imports: [NgtCameraHelper], exports: [NgtCameraHelper] });
NgtCameraHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCameraHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCameraHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtCameraHelper],
                    exports: [NgtCameraHelper],
                }]
        }] });

// GENERATED
class NgtDirectionalLightHelper extends NgtCommonObjectHelper {
    set ngtDirectionalLightHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.DirectionalLightHelper;
    }
}
NgtDirectionalLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtDirectionalLightHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtDirectionalLightHelper, isStandalone: true, selector: "[ngtDirectionalLightHelper]", inputs: { ngtDirectionalLightHelper: "ngtDirectionalLightHelper" }, providers: [
        provideNgtCommonObjectHelper(NgtDirectionalLightHelper),
        provideCommonObjectHelperRef(NgtDirectionalLightHelper),
    ], exportAs: ["ngtDirectionalLightHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtDirectionalLightHelper]',
                    standalone: true,
                    exportAs: 'ngtDirectionalLightHelper',
                    providers: [
                        provideNgtCommonObjectHelper(NgtDirectionalLightHelper),
                        provideCommonObjectHelperRef(NgtDirectionalLightHelper),
                    ],
                }]
        }], propDecorators: { ngtDirectionalLightHelper: [{
                type: Input
            }] } });
class NgtDirectionalLightHelperModule {
}
NgtDirectionalLightHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtDirectionalLightHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightHelperModule, imports: [NgtDirectionalLightHelper], exports: [NgtDirectionalLightHelper] });
NgtDirectionalLightHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtDirectionalLightHelper],
                    exports: [NgtDirectionalLightHelper],
                }]
        }] });

// GENERATED
class NgtHemisphereLightHelper extends NgtCommonObjectHelper {
    set ngtHemisphereLightHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.HemisphereLightHelper;
    }
}
NgtHemisphereLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtHemisphereLightHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtHemisphereLightHelper, isStandalone: true, selector: "[ngtHemisphereLightHelper]", inputs: { ngtHemisphereLightHelper: "ngtHemisphereLightHelper" }, providers: [
        provideNgtCommonObjectHelper(NgtHemisphereLightHelper),
        provideCommonObjectHelperRef(NgtHemisphereLightHelper),
    ], exportAs: ["ngtHemisphereLightHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtHemisphereLightHelper]',
                    standalone: true,
                    exportAs: 'ngtHemisphereLightHelper',
                    providers: [
                        provideNgtCommonObjectHelper(NgtHemisphereLightHelper),
                        provideCommonObjectHelperRef(NgtHemisphereLightHelper),
                    ],
                }]
        }], propDecorators: { ngtHemisphereLightHelper: [{
                type: Input
            }] } });
class NgtHemisphereLightHelperModule {
}
NgtHemisphereLightHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtHemisphereLightHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightHelperModule, imports: [NgtHemisphereLightHelper], exports: [NgtHemisphereLightHelper] });
NgtHemisphereLightHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtHemisphereLightHelper],
                    exports: [NgtHemisphereLightHelper],
                }]
        }] });

// GENERATED
class NgtPlaneHelper extends NgtCommonObjectHelper {
    set ngtPlaneHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.PlaneHelper;
    }
}
NgtPlaneHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPlaneHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtPlaneHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtPlaneHelper, isStandalone: true, selector: "[ngtPlaneHelper]", inputs: { ngtPlaneHelper: "ngtPlaneHelper" }, providers: [provideNgtCommonObjectHelper(NgtPlaneHelper), provideCommonObjectHelperRef(NgtPlaneHelper)], exportAs: ["ngtPlaneHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPlaneHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtPlaneHelper]',
                    standalone: true,
                    exportAs: 'ngtPlaneHelper',
                    providers: [provideNgtCommonObjectHelper(NgtPlaneHelper), provideCommonObjectHelperRef(NgtPlaneHelper)],
                }]
        }], propDecorators: { ngtPlaneHelper: [{
                type: Input
            }] } });
class NgtPlaneHelperModule {
}
NgtPlaneHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPlaneHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPlaneHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtPlaneHelperModule, imports: [NgtPlaneHelper], exports: [NgtPlaneHelper] });
NgtPlaneHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPlaneHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPlaneHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtPlaneHelper],
                    exports: [NgtPlaneHelper],
                }]
        }] });

// GENERATED
class NgtPointLightHelper extends NgtCommonObjectHelper {
    set ngtPointLightHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.PointLightHelper;
    }
}
NgtPointLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtPointLightHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtPointLightHelper, isStandalone: true, selector: "[ngtPointLightHelper]", inputs: { ngtPointLightHelper: "ngtPointLightHelper" }, providers: [provideNgtCommonObjectHelper(NgtPointLightHelper), provideCommonObjectHelperRef(NgtPointLightHelper)], exportAs: ["ngtPointLightHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtPointLightHelper]',
                    standalone: true,
                    exportAs: 'ngtPointLightHelper',
                    providers: [provideNgtCommonObjectHelper(NgtPointLightHelper), provideCommonObjectHelperRef(NgtPointLightHelper)],
                }]
        }], propDecorators: { ngtPointLightHelper: [{
                type: Input
            }] } });
class NgtPointLightHelperModule {
}
NgtPointLightHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPointLightHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightHelperModule, imports: [NgtPointLightHelper], exports: [NgtPointLightHelper] });
NgtPointLightHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtPointLightHelper],
                    exports: [NgtPointLightHelper],
                }]
        }] });

// GENERATED
class NgtSkeletonHelper extends NgtCommonObjectHelper {
    set ngtSkeletonHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.SkeletonHelper;
    }
}
NgtSkeletonHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeletonHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtSkeletonHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtSkeletonHelper, isStandalone: true, selector: "[ngtSkeletonHelper]", inputs: { ngtSkeletonHelper: "ngtSkeletonHelper" }, providers: [provideNgtCommonObjectHelper(NgtSkeletonHelper), provideCommonObjectHelperRef(NgtSkeletonHelper)], exportAs: ["ngtSkeletonHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeletonHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtSkeletonHelper]',
                    standalone: true,
                    exportAs: 'ngtSkeletonHelper',
                    providers: [provideNgtCommonObjectHelper(NgtSkeletonHelper), provideCommonObjectHelperRef(NgtSkeletonHelper)],
                }]
        }], propDecorators: { ngtSkeletonHelper: [{
                type: Input
            }] } });
class NgtSkeletonHelperModule {
}
NgtSkeletonHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeletonHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSkeletonHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeletonHelperModule, imports: [NgtSkeletonHelper], exports: [NgtSkeletonHelper] });
NgtSkeletonHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeletonHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeletonHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtSkeletonHelper],
                    exports: [NgtSkeletonHelper],
                }]
        }] });

// GENERATED
class NgtSpotLightHelper extends NgtCommonObjectHelper {
    set ngtSpotLightHelper(v) {
        if (v) {
            this.instanceArgs = v;
        }
    }
    get objectHelperType() {
        return THREE.SpotLightHelper;
    }
}
NgtSpotLightHelper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightHelper, deps: null, target: i0.ɵɵFactoryTarget.Directive });
NgtSpotLightHelper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtSpotLightHelper, isStandalone: true, selector: "[ngtSpotLightHelper]", inputs: { ngtSpotLightHelper: "ngtSpotLightHelper" }, providers: [provideNgtCommonObjectHelper(NgtSpotLightHelper), provideCommonObjectHelperRef(NgtSpotLightHelper)], exportAs: ["ngtSpotLightHelper"], usesInheritance: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightHelper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtSpotLightHelper]',
                    standalone: true,
                    exportAs: 'ngtSpotLightHelper',
                    providers: [provideNgtCommonObjectHelper(NgtSpotLightHelper), provideCommonObjectHelperRef(NgtSpotLightHelper)],
                }]
        }], propDecorators: { ngtSpotLightHelper: [{
                type: Input
            }] } });
class NgtSpotLightHelperModule {
}
NgtSpotLightHelperModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightHelperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSpotLightHelperModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightHelperModule, imports: [NgtSpotLightHelper], exports: [NgtSpotLightHelper] });
NgtSpotLightHelperModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightHelperModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightHelperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtSpotLightHelper],
                    exports: [NgtSpotLightHelper],
                }]
        }] });

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtArrowHelper, NgtArrowHelperModule, NgtAxesHelper, NgtAxesHelperModule, NgtBox3Helper, NgtBox3HelperModule, NgtBoxHelper, NgtBoxHelperModule, NgtCameraHelper, NgtCameraHelperModule, NgtDirectionalLightHelper, NgtDirectionalLightHelperModule, NgtGridHelper, NgtGridHelperModule, NgtHemisphereLightHelper, NgtHemisphereLightHelperModule, NgtPlaneHelper, NgtPlaneHelperModule, NgtPointLightHelper, NgtPointLightHelperModule, NgtPolarGridHelper, NgtPolarGridHelperModule, NgtSkeletonHelper, NgtSkeletonHelperModule, NgtSpotLightHelper, NgtSpotLightHelperModule };
//# sourceMappingURL=angular-three-core-helpers.mjs.map
