import { NgtCommonMesh, provideNgtCommonMesh, provideCommonMeshRef, coerceNumberProperty, coerceBooleanProperty, make, NgtInstance, injectSkinnedMeshHostRef, tapEffect, provideNgtInstance, provideInstanceRef, NgtObject, injectBoneHostRef, injectSkeletonHostRef, provideNgtObject, provideObjectRef } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, NgModule, Input, inject } from '@angular/core';
import * as THREE from 'three';
import { pipe, withLatestFrom } from 'rxjs';

class NgtMesh extends NgtCommonMesh {
    get meshType() {
        return THREE.Mesh;
    }
}
NgtMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtMesh, isStandalone: true, selector: "ngt-mesh", providers: [provideNgtCommonMesh(NgtMesh), provideCommonMeshRef(NgtMesh)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-mesh',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonMesh(NgtMesh), provideCommonMeshRef(NgtMesh)],
                }]
        }] });
class NgtMeshModule {
}
NgtMeshModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtMeshModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtMeshModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtMeshModule, imports: [NgtMesh], exports: [NgtMesh] });
NgtMeshModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtMeshModule, imports: [NgtMesh] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtMeshModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtMesh],
                    exports: [NgtMesh],
                }]
        }] });

class NgtInstancedMesh extends NgtCommonMesh {
    set count(count) {
        this.set({ count: coerceNumberProperty(count) });
    }
    get meshType() {
        return THREE.InstancedMesh;
    }
    postPrepare(instancedMesh) {
        instancedMesh.instanceMatrix.setUsage(THREE.DynamicDrawUsage);
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { count: false });
    }
    get argsKeys() {
        return ['count'];
    }
}
NgtInstancedMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtInstancedMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtInstancedMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtInstancedMesh, isStandalone: true, selector: "ngt-instanced-mesh[count]", inputs: { count: "count" }, providers: [provideNgtCommonMesh(NgtInstancedMesh), provideCommonMeshRef(NgtInstancedMesh)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtInstancedMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-instanced-mesh[count]',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonMesh(NgtInstancedMesh), provideCommonMeshRef(NgtInstancedMesh)],
                }]
        }], propDecorators: { count: [{
                type: Input
            }] } });
class NgtInstancedMeshModule {
}
NgtInstancedMeshModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtInstancedMeshModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtInstancedMeshModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtInstancedMeshModule, imports: [NgtInstancedMesh], exports: [NgtInstancedMesh] });
NgtInstancedMeshModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtInstancedMeshModule, imports: [NgtInstancedMesh] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtInstancedMeshModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtInstancedMesh],
                    exports: [NgtInstancedMesh],
                }]
        }] });

class NgtSkinnedMesh extends NgtCommonMesh {
    set skeleton(skeleton) {
        this.set({ skeleton });
    }
    set useVertexTexture(useVertexTexture) {
        this.set({ useVertexTexture: coerceBooleanProperty(useVertexTexture) });
    }
    set bindMatrix(bindMatrix) {
        this.set({ bindMatrix: make(THREE.Matrix4, bindMatrix) });
    }
    set bindMatrixInverse(bindMatrixInverse) {
        this.set({
            bindMatrixInverse: make(THREE.Matrix4, bindMatrixInverse),
        });
    }
    set bindMode(bindMode) {
        this.set({ bindMode });
    }
    get meshType() {
        return THREE.SkinnedMesh;
    }
    get argsKeys() {
        return ['useVertexTexture'];
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { bindMatrix: true, bindMatrixInverse: true, bindMode: true, skeleton: true });
    }
    bind(skeleton) {
        this.instance.value.bind(skeleton, this.get((s) => s['bindMatrix']));
    }
}
NgtSkinnedMesh.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkinnedMesh, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtSkinnedMesh.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtSkinnedMesh, isStandalone: true, selector: "ngt-skinned-mesh", inputs: { skeleton: "skeleton", useVertexTexture: "useVertexTexture", bindMatrix: "bindMatrix", bindMatrixInverse: "bindMatrixInverse", bindMode: "bindMode" }, providers: [provideNgtCommonMesh(NgtSkinnedMesh), provideCommonMeshRef(NgtSkinnedMesh)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkinnedMesh, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-skinned-mesh',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonMesh(NgtSkinnedMesh), provideCommonMeshRef(NgtSkinnedMesh)],
                }]
        }], propDecorators: { skeleton: [{
                type: Input
            }], useVertexTexture: [{
                type: Input
            }], bindMatrix: [{
                type: Input
            }], bindMatrixInverse: [{
                type: Input
            }], bindMode: [{
                type: Input
            }] } });
class NgtSkeleton extends NgtInstance {
    constructor() {
        super();
        this.skinnedMesh = inject(NgtSkinnedMesh, { optional: true });
        this.parentRef = (() => { var _a; return (_a = this.skinnedMesh) === null || _a === void 0 ? void 0 : _a.instance; });
        this.parentHostRef = injectSkinnedMeshHostRef({ optional: true, skipSelf: true });
        this.init = this.effect(pipe(withLatestFrom(this.select(this.select((s) => s.bones), this.select((s) => s.boneInverses), (bones, boneInverses) => ({ bones, boneInverses }))), tapEffect(([instanceArgs, { bones, boneInverses }]) => {
            var _a, _b;
            const skeletonArgs = [...instanceArgs];
            if (skeletonArgs.length === 0) {
                if (bones.length) {
                    skeletonArgs[0] = bones;
                }
                if (boneInverses.length) {
                    skeletonArgs[1] = boneInverses;
                }
            }
            const skeleton = this.prepareInstance(new THREE.Skeleton(...skeletonArgs));
            if (!((_a = this.skinnedMesh) === null || _a === void 0 ? void 0 : _a.instance.value.skeleton)) {
                (_b = this.skinnedMesh) === null || _b === void 0 ? void 0 : _b.bind(skeleton);
            }
            return () => {
                skeleton.dispose();
            };
        })));
        if (this.parentHostRef && !this.parentHostRef().value.isSkinnedMesh) {
            throw new Error('<ngt-skeleton> can only be used within <ngt-skinned-mesh>');
        }
    }
    set args(args) {
        this.set({ instanceArgs: args });
    }
    set bones(bones) {
        this.set({ bones });
    }
    set boneInverses(boneInverses) {
        this.set({
            boneInverses: boneInverses.map((datum) => make(THREE.Matrix4, datum)),
        });
    }
    set boneMatrices(boneMatrices) {
        this.set({ boneMatrices });
    }
    set boneTexture(boneTexture) {
        this.set({ boneTexture });
    }
    set boneTextureSize(boneTextureSize) {
        this.set({ boneTextureSize: coerceNumberProperty(boneTextureSize) });
    }
    set frame(frame) {
        this.set({ frame: coerceNumberProperty(frame) });
    }
    preInit() {
        this.set((state) => ({
            attach: state.attach.length ? state.attach : ['skeleton'],
            bones: state.bones || [],
            boneInverses: state.boneInverses || [],
            boneMatrices: state.boneMatrices || null,
            boneTexture: state.boneTexture || null,
            boneTextureSize: state.boneTextureSize || 0,
            frame: state.frame || -1,
        }));
    }
    ngOnInit() {
        super.ngOnInit();
        this.store.onReady(() => {
            this.init(this.instanceArgs$);
        });
    }
    get optionFields() {
        return Object.assign(Object.assign({}, super.optionFields), { bones: false, boneTexture: false, boneTextureSize: false, boneMatrices: false, boneInverses: false, frame: false });
    }
}
NgtSkeleton.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeleton, deps: [], target: i0.ɵɵFactoryTarget.Component });
NgtSkeleton.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtSkeleton, isStandalone: true, selector: "ngt-skeleton", inputs: { args: "args", bones: "bones", boneInverses: "boneInverses", boneMatrices: "boneMatrices", boneTexture: "boneTexture", boneTextureSize: "boneTextureSize", frame: "frame" }, providers: [provideNgtInstance(NgtSkeleton), provideInstanceRef(NgtSkeleton)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkeleton, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-skeleton',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtInstance(NgtSkeleton), provideInstanceRef(NgtSkeleton)],
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { args: [{
                type: Input
            }], bones: [{
                type: Input
            }], boneInverses: [{
                type: Input
            }], boneMatrices: [{
                type: Input
            }], boneTexture: [{
                type: Input
            }], boneTextureSize: [{
                type: Input
            }], frame: [{
                type: Input
            }] } });
class NgtBone extends NgtObject {
    constructor() {
        super(...arguments);
        this.hostBoneRef = injectBoneHostRef({ skipSelf: true, optional: true });
        this.hostSkeletonRef = injectSkeletonHostRef({ skipSelf: true, optional: true });
        this.hostSkinnedMeshRef = injectSkinnedMeshHostRef({ skipSelf: true, optional: true });
        this.parentBone = inject(NgtBone, { skipSelf: true, optional: true });
        this.parentSkinnedMesh = inject(NgtSkinnedMesh, { optional: true });
        this.parentSkeleton = inject(NgtSkeleton, { optional: true });
        this.parentRef = (() => { var _a, _b; return ((_a = this.parentBone) === null || _a === void 0 ? void 0 : _a.instance) || ((_b = this.parentSkinnedMesh) === null || _b === void 0 ? void 0 : _b.instance); });
        this.parentHostRef = this.hostBoneRef || this.hostSkinnedMeshRef;
    }
    objectInitFn() {
        return new THREE.Bone();
    }
    postPrepare(bone) {
        if (this.parentSkeleton) {
            this.parentSkeleton.instance.value.bones.push(bone);
        }
        else if (this.hostSkeletonRef) {
            this.hostSkeletonRef().value.bones.push(bone);
        }
    }
}
NgtBone.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBone, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtBone.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtBone, isStandalone: true, selector: "ngt-bone", providers: [provideNgtObject(NgtBone), provideObjectRef(NgtBone)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtBone, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-bone',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtObject(NgtBone), provideObjectRef(NgtBone)],
                }]
        }] });
class NgtSkinnedMeshModule {
}
NgtSkinnedMeshModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkinnedMeshModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSkinnedMeshModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtSkinnedMeshModule, imports: [NgtSkinnedMesh, NgtSkeleton, NgtBone], exports: [NgtSkinnedMesh, NgtSkeleton, NgtBone] });
NgtSkinnedMeshModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkinnedMeshModule, imports: [NgtSkinnedMesh, NgtSkeleton, NgtBone] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSkinnedMeshModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtSkinnedMesh, NgtSkeleton, NgtBone],
                    exports: [NgtSkinnedMesh, NgtSkeleton, NgtBone],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NgtBone, NgtInstancedMesh, NgtInstancedMeshModule, NgtMesh, NgtMeshModule, NgtSkeleton, NgtSkinnedMesh, NgtSkinnedMeshModule };
//# sourceMappingURL=angular-three-core-meshes.mjs.map
