import { NgtObject, is, tapEffect, provideNgtObject, provideObjectRef } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule } from '@angular/core';
import { filter } from 'rxjs';

class NgtPrimitive extends NgtObject {
    constructor() {
        super(...arguments);
        this.object$ = this.select((s) => s.object).pipe(filter((object) => object != null));
        this.isPrimitive = true;
    }
    set object(object) {
        if (is.ref(object)) {
            this.ref = object;
            this.set({ object: object.value });
        }
        else {
            this.set({ object: object });
        }
    }
    get object() {
        return this.get((s) => s.object);
    }
    objectInitFn() {
        return this.object;
    }
    get preObjectInit() {
        return (initFn) => {
            this.effect(tapEffect(() => {
                // TODO: determine whether we should run clean up logic if object is undefined/null
                initFn();
            }))(this.object$);
        };
    }
}
NgtPrimitive.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPrimitive, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtPrimitive.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtPrimitive, isStandalone: true, selector: "ngt-primitive[object]", inputs: { object: "object" }, providers: [provideNgtObject(NgtPrimitive), provideObjectRef(NgtPrimitive)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPrimitive, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-primitive[object]',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtObject(NgtPrimitive), provideObjectRef(NgtPrimitive)],
                }]
        }], propDecorators: { object: [{
                type: Input
            }] } });
class NgtPrimitiveModule {
}
NgtPrimitiveModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPrimitiveModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPrimitiveModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtPrimitiveModule, imports: [NgtPrimitive], exports: [NgtPrimitive] });
NgtPrimitiveModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPrimitiveModule, imports: [NgtPrimitive] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPrimitiveModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtPrimitive],
                    exports: [NgtPrimitive],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { NgtPrimitive, NgtPrimitiveModule };
//# sourceMappingURL=angular-three-core-primitive.mjs.map
