import { NgtCommonCamera, coerceNumberProperty, provideNgtCommonCamera, provideCommonCameraRef, NgtObject, tapEffect, provideNgtObject, provideObjectRef } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule } from '@angular/core';
import * as THREE from 'three';

// GENERATED
class NgtPerspectiveCamera extends NgtCommonCamera {
    set fov(fov) {
        this.set({ fov: coerceNumberProperty(fov) });
    }
    set aspect(aspect) {
        this.set({ aspect: coerceNumberProperty(aspect) });
    }
    set near(near) {
        this.set({ near: coerceNumberProperty(near) });
    }
    set far(far) {
        this.set({ far: coerceNumberProperty(far) });
    }
    get cameraType() {
        return THREE.PerspectiveCamera;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            fov: true,
            aspect: true,
            near: true,
            far: true,
        };
    }
}
NgtPerspectiveCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPerspectiveCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtPerspectiveCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtPerspectiveCamera, isStandalone: true, selector: "ngt-perspective-camera", inputs: { fov: "fov", aspect: "aspect", near: "near", far: "far" }, providers: [provideNgtCommonCamera(NgtPerspectiveCamera), provideCommonCameraRef(NgtPerspectiveCamera)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPerspectiveCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-perspective-camera',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonCamera(NgtPerspectiveCamera), provideCommonCameraRef(NgtPerspectiveCamera)],
                }]
        }], propDecorators: { fov: [{
                type: Input
            }], aspect: [{
                type: Input
            }], near: [{
                type: Input
            }], far: [{
                type: Input
            }] } });
class NgtPerspectiveCameraModule {
}
NgtPerspectiveCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPerspectiveCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPerspectiveCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtPerspectiveCameraModule, imports: [NgtPerspectiveCamera], exports: [NgtPerspectiveCamera] });
NgtPerspectiveCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPerspectiveCameraModule, imports: [NgtPerspectiveCamera] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPerspectiveCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtPerspectiveCamera],
                    exports: [NgtPerspectiveCamera],
                }]
        }] });

// GENERATED
class NgtOrthographicCamera extends NgtCommonCamera {
    set left(left) {
        this.set({ left: coerceNumberProperty(left) });
    }
    set right(right) {
        this.set({ right: coerceNumberProperty(right) });
    }
    set top(top) {
        this.set({ top: coerceNumberProperty(top) });
    }
    set bottom(bottom) {
        this.set({ bottom: coerceNumberProperty(bottom) });
    }
    set near(near) {
        this.set({ near: coerceNumberProperty(near) });
    }
    set far(far) {
        this.set({ far: coerceNumberProperty(far) });
    }
    get cameraType() {
        return THREE.OrthographicCamera;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            left: true,
            right: true,
            top: true,
            bottom: true,
            near: true,
            far: true,
        };
    }
}
NgtOrthographicCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtOrthographicCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtOrthographicCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtOrthographicCamera, isStandalone: true, selector: "ngt-orthographic-camera", inputs: { left: "left", right: "right", top: "top", bottom: "bottom", near: "near", far: "far" }, providers: [provideNgtCommonCamera(NgtOrthographicCamera), provideCommonCameraRef(NgtOrthographicCamera)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtOrthographicCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-orthographic-camera',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonCamera(NgtOrthographicCamera), provideCommonCameraRef(NgtOrthographicCamera)],
                }]
        }], propDecorators: { left: [{
                type: Input
            }], right: [{
                type: Input
            }], top: [{
                type: Input
            }], bottom: [{
                type: Input
            }], near: [{
                type: Input
            }], far: [{
                type: Input
            }] } });
class NgtOrthographicCameraModule {
}
NgtOrthographicCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtOrthographicCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtOrthographicCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtOrthographicCameraModule, imports: [NgtOrthographicCamera], exports: [NgtOrthographicCamera] });
NgtOrthographicCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtOrthographicCameraModule, imports: [NgtOrthographicCamera] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtOrthographicCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtOrthographicCamera],
                    exports: [NgtOrthographicCamera],
                }]
        }] });

// GENERATED
class NgtArrayCamera extends NgtCommonCamera {
    set cameras(cameras) {
        this.set({ cameras });
    }
    get cameraType() {
        return THREE.ArrayCamera;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            cameras: true,
        };
    }
}
NgtArrayCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrayCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtArrayCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtArrayCamera, isStandalone: true, selector: "ngt-array-camera", inputs: { cameras: "cameras" }, providers: [provideNgtCommonCamera(NgtArrayCamera), provideCommonCameraRef(NgtArrayCamera)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrayCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-array-camera',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonCamera(NgtArrayCamera), provideCommonCameraRef(NgtArrayCamera)],
                }]
        }], propDecorators: { cameras: [{
                type: Input
            }] } });
class NgtArrayCameraModule {
}
NgtArrayCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrayCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtArrayCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtArrayCameraModule, imports: [NgtArrayCamera], exports: [NgtArrayCamera] });
NgtArrayCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrayCameraModule, imports: [NgtArrayCamera] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtArrayCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtArrayCamera],
                    exports: [NgtArrayCamera],
                }]
        }] });

// GENERATED
class NgtStereoCamera extends NgtCommonCamera {
    get cameraType() {
        return THREE.StereoCamera;
    }
}
NgtStereoCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtStereoCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtStereoCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtStereoCamera, isStandalone: true, selector: "ngt-stereo-camera", providers: [provideNgtCommonCamera(NgtStereoCamera), provideCommonCameraRef(NgtStereoCamera)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtStereoCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-stereo-camera',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonCamera(NgtStereoCamera), provideCommonCameraRef(NgtStereoCamera)],
                }]
        }] });
class NgtStereoCameraModule {
}
NgtStereoCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtStereoCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtStereoCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtStereoCameraModule, imports: [NgtStereoCamera], exports: [NgtStereoCamera] });
NgtStereoCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtStereoCameraModule, imports: [NgtStereoCamera] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtStereoCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtStereoCamera],
                    exports: [NgtStereoCamera],
                }]
        }] });

class NgtCubeCamera extends NgtObject {
    set args(args) {
        this.set({ instanceArgs: args });
    }
    set near(near) {
        this.set({ near: coerceNumberProperty(near) });
    }
    set far(far) {
        this.set({ far: coerceNumberProperty(far) });
    }
    set renderTarget(renderTarget) {
        this.set({ renderTarget });
    }
    objectInitFn() {
        const args = this.get((s) => s.instanceArgs);
        return new THREE.CubeCamera(...args);
    }
    get preObjectInit() {
        return (initFn) => {
            const args = this.get((s) => s.instanceArgs);
            if (args && args.length) {
                this.set({
                    near: args[0],
                    far: args[1],
                    renderTarget: args[2],
                });
            }
            this.effect(tapEffect(() => {
                initFn();
            }))(this.instanceArgs$);
        };
    }
    get optionFields() {
        return {
            ...super.optionFields,
            near: false,
            far: false,
            renderTarget: false,
        };
    }
}
NgtCubeCamera.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCubeCamera, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtCubeCamera.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtCubeCamera, isStandalone: true, selector: "ngt-cube-camera", inputs: { args: "args", near: "near", far: "far", renderTarget: "renderTarget" }, providers: [provideNgtObject(NgtCubeCamera), provideObjectRef(NgtCubeCamera)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCubeCamera, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-cube-camera',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtObject(NgtCubeCamera), provideObjectRef(NgtCubeCamera)],
                }]
        }], propDecorators: { args: [{
                type: Input
            }], near: [{
                type: Input
            }], far: [{
                type: Input
            }], renderTarget: [{
                type: Input
            }] } });
class NgtCubeCameraModule {
}
NgtCubeCameraModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCubeCameraModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtCubeCameraModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtCubeCameraModule, imports: [NgtCubeCamera], exports: [NgtCubeCamera] });
NgtCubeCameraModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCubeCameraModule, imports: [NgtCubeCamera] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtCubeCameraModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtCubeCamera],
                    exports: [NgtCubeCamera],
                }]
        }] });

// GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtArrayCamera, NgtArrayCameraModule, NgtCubeCamera, NgtCubeCameraModule, NgtOrthographicCamera, NgtOrthographicCameraModule, NgtPerspectiveCamera, NgtPerspectiveCameraModule, NgtStereoCamera, NgtStereoCameraModule };
//# sourceMappingURL=angular-three-core-cameras.mjs.map
