import { NgtCommonLight, provideNgtCommonLight, provideCommonLightRef, coerceNumberProperty, createPassThroughInput } from '@angular-three/core';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, NgModule, Directive, Self, Optional } from '@angular/core';
import * as THREE from 'three';

// GENERATED
class NgtLightProbe extends NgtCommonLight {
    set sh(sh) {
        this.set({ sh });
    }
    get lightType() {
        return THREE.LightProbe;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            sh: true,
        };
    }
}
NgtLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtLightProbe, isStandalone: true, selector: "ngt-light-probe", inputs: { sh: "sh" }, providers: [provideNgtCommonLight(NgtLightProbe), provideCommonLightRef(NgtLightProbe)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-light-probe',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtLightProbe), provideCommonLightRef(NgtLightProbe)],
                }]
        }], propDecorators: { sh: [{
                type: Input
            }] } });
class NgtLightProbeModule {
}
NgtLightProbeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtLightProbeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtLightProbeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtLightProbeModule, imports: [NgtLightProbe], exports: [NgtLightProbe] });
NgtLightProbeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtLightProbeModule, imports: [NgtLightProbe] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtLightProbeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtLightProbe],
                    exports: [NgtLightProbe],
                }]
        }] });

// GENERATED
class NgtAmbientLight extends NgtCommonLight {
    get lightType() {
        return THREE.AmbientLight;
    }
}
NgtAmbientLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtAmbientLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtAmbientLight, isStandalone: true, selector: "ngt-ambient-light", providers: [provideNgtCommonLight(NgtAmbientLight), provideCommonLightRef(NgtAmbientLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-ambient-light',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtAmbientLight), provideCommonLightRef(NgtAmbientLight)],
                }]
        }] });
class NgtAmbientLightModule {
}
NgtAmbientLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAmbientLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightModule, imports: [NgtAmbientLight], exports: [NgtAmbientLight] });
NgtAmbientLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightModule, imports: [NgtAmbientLight] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtAmbientLight],
                    exports: [NgtAmbientLight],
                }]
        }] });

// GENERATED
class NgtAmbientLightProbe extends NgtCommonLight {
    get lightType() {
        return THREE.AmbientLightProbe;
    }
}
NgtAmbientLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtAmbientLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtAmbientLightProbe, isStandalone: true, selector: "ngt-ambient-light-probe", providers: [provideNgtCommonLight(NgtAmbientLightProbe), provideCommonLightRef(NgtAmbientLightProbe)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-ambient-light-probe',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtAmbientLightProbe), provideCommonLightRef(NgtAmbientLightProbe)],
                }]
        }] });
class NgtAmbientLightProbeModule {
}
NgtAmbientLightProbeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightProbeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtAmbientLightProbeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightProbeModule, imports: [NgtAmbientLightProbe], exports: [NgtAmbientLightProbe] });
NgtAmbientLightProbeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightProbeModule, imports: [NgtAmbientLightProbe] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtAmbientLightProbeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtAmbientLightProbe],
                    exports: [NgtAmbientLightProbe],
                }]
        }] });

// GENERATED
class NgtHemisphereLight extends NgtCommonLight {
    set skyColor(skyColor) {
        this.set({ skyColor });
    }
    set groundColor(groundColor) {
        this.set({ groundColor });
    }
    get lightType() {
        return THREE.HemisphereLight;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            skyColor: true,
            groundColor: true,
        };
    }
}
NgtHemisphereLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtHemisphereLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtHemisphereLight, isStandalone: true, selector: "ngt-hemisphere-light", inputs: { skyColor: "skyColor", groundColor: "groundColor" }, providers: [provideNgtCommonLight(NgtHemisphereLight), provideCommonLightRef(NgtHemisphereLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-hemisphere-light',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtHemisphereLight), provideCommonLightRef(NgtHemisphereLight)],
                }]
        }], propDecorators: { skyColor: [{
                type: Input
            }], groundColor: [{
                type: Input
            }] } });
class NgtHemisphereLightModule {
}
NgtHemisphereLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtHemisphereLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightModule, imports: [NgtHemisphereLight], exports: [NgtHemisphereLight] });
NgtHemisphereLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightModule, imports: [NgtHemisphereLight] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtHemisphereLight],
                    exports: [NgtHemisphereLight],
                }]
        }] });

// GENERATED
class NgtHemisphereLightProbe extends NgtCommonLight {
    set skyColor(skyColor) {
        this.set({ skyColor });
    }
    set groundColor(groundColor) {
        this.set({ groundColor });
    }
    get lightType() {
        return THREE.HemisphereLightProbe;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            skyColor: true,
            groundColor: true,
        };
    }
}
NgtHemisphereLightProbe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightProbe, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtHemisphereLightProbe.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtHemisphereLightProbe, isStandalone: true, selector: "ngt-hemisphere-light-probe", inputs: { skyColor: "skyColor", groundColor: "groundColor" }, providers: [provideNgtCommonLight(NgtHemisphereLightProbe), provideCommonLightRef(NgtHemisphereLightProbe)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightProbe, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-hemisphere-light-probe',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtHemisphereLightProbe), provideCommonLightRef(NgtHemisphereLightProbe)],
                }]
        }], propDecorators: { skyColor: [{
                type: Input
            }], groundColor: [{
                type: Input
            }] } });
class NgtHemisphereLightProbeModule {
}
NgtHemisphereLightProbeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightProbeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtHemisphereLightProbeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightProbeModule, imports: [NgtHemisphereLightProbe], exports: [NgtHemisphereLightProbe] });
NgtHemisphereLightProbeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightProbeModule, imports: [NgtHemisphereLightProbe] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtHemisphereLightProbeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtHemisphereLightProbe],
                    exports: [NgtHemisphereLightProbe],
                }]
        }] });

// GENERATED
class NgtDirectionalLight extends NgtCommonLight {
    set target(target) {
        this.set({ target });
    }
    get lightType() {
        return THREE.DirectionalLight;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            target: true,
        };
    }
}
NgtDirectionalLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtDirectionalLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtDirectionalLight, isStandalone: true, selector: "ngt-directional-light", inputs: { target: "target" }, providers: [provideNgtCommonLight(NgtDirectionalLight), provideCommonLightRef(NgtDirectionalLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-directional-light',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtDirectionalLight), provideCommonLightRef(NgtDirectionalLight)],
                }]
        }], propDecorators: { target: [{
                type: Input
            }] } });
class NgtDirectionalLightModule {
}
NgtDirectionalLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtDirectionalLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightModule, imports: [NgtDirectionalLight], exports: [NgtDirectionalLight] });
NgtDirectionalLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightModule, imports: [NgtDirectionalLight] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtDirectionalLightModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtDirectionalLight],
                    exports: [NgtDirectionalLight],
                }]
        }] });

// GENERATED
class NgtPointLight extends NgtCommonLight {
    set distance(distance) {
        this.set({ distance: coerceNumberProperty(distance) });
    }
    set decay(decay) {
        this.set({ decay: coerceNumberProperty(decay) });
    }
    set power(power) {
        this.set({ power: coerceNumberProperty(power) });
    }
    get lightType() {
        return THREE.PointLight;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            distance: true,
            decay: true,
            power: true,
        };
    }
}
NgtPointLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtPointLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtPointLight, isStandalone: true, selector: "ngt-point-light", inputs: { distance: "distance", decay: "decay", power: "power" }, providers: [provideNgtCommonLight(NgtPointLight), provideCommonLightRef(NgtPointLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-point-light',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtPointLight), provideCommonLightRef(NgtPointLight)],
                }]
        }], propDecorators: { distance: [{
                type: Input
            }], decay: [{
                type: Input
            }], power: [{
                type: Input
            }] } });
class NgtPointLightModule {
}
NgtPointLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtPointLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightModule, imports: [NgtPointLight], exports: [NgtPointLight] });
NgtPointLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightModule, imports: [NgtPointLight] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtPointLightModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtPointLight],
                    exports: [NgtPointLight],
                }]
        }] });

// GENERATED
class NgtSpotLight extends NgtCommonLight {
    set distance(distance) {
        this.set({ distance: coerceNumberProperty(distance) });
    }
    set angle(angle) {
        this.set({ angle: coerceNumberProperty(angle) });
    }
    set penumbra(penumbra) {
        this.set({ penumbra: coerceNumberProperty(penumbra) });
    }
    set decay(decay) {
        this.set({ decay: coerceNumberProperty(decay) });
    }
    set target(target) {
        this.set({ target });
    }
    set power(power) {
        this.set({ power: coerceNumberProperty(power) });
    }
    get lightType() {
        return THREE.SpotLight;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            distance: true,
            angle: true,
            penumbra: true,
            decay: true,
            target: true,
            power: true,
        };
    }
}
NgtSpotLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtSpotLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtSpotLight, isStandalone: true, selector: "ngt-spot-light", inputs: { distance: "distance", angle: "angle", penumbra: "penumbra", decay: "decay", target: "target", power: "power" }, providers: [provideNgtCommonLight(NgtSpotLight), provideCommonLightRef(NgtSpotLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-spot-light',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtSpotLight), provideCommonLightRef(NgtSpotLight)],
                }]
        }], propDecorators: { distance: [{
                type: Input
            }], angle: [{
                type: Input
            }], penumbra: [{
                type: Input
            }], decay: [{
                type: Input
            }], target: [{
                type: Input
            }], power: [{
                type: Input
            }] } });
class NgtSpotLightModule {
}
NgtSpotLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSpotLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightModule, imports: [NgtSpotLight], exports: [NgtSpotLight] });
NgtSpotLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightModule, imports: [NgtSpotLight] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtSpotLight],
                    exports: [NgtSpotLight],
                }]
        }] });

// GENERATED
class NgtRectAreaLight extends NgtCommonLight {
    set width(width) {
        this.set({ width: coerceNumberProperty(width) });
    }
    set height(height) {
        this.set({ height: coerceNumberProperty(height) });
    }
    set power(power) {
        this.set({ power: coerceNumberProperty(power) });
    }
    get lightType() {
        return THREE.RectAreaLight;
    }
    get optionFields() {
        return {
            ...super.optionFields,
            width: true,
            height: true,
            power: true,
        };
    }
}
NgtRectAreaLight.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtRectAreaLight, deps: null, target: i0.ɵɵFactoryTarget.Component });
NgtRectAreaLight.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: NgtRectAreaLight, isStandalone: true, selector: "ngt-rect-area-light", inputs: { width: "width", height: "height", power: "power" }, providers: [provideNgtCommonLight(NgtRectAreaLight), provideCommonLightRef(NgtRectAreaLight)], usesInheritance: true, ngImport: i0, template: '<ng-content></ng-content>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtRectAreaLight, decorators: [{
            type: Component,
            args: [{
                    selector: 'ngt-rect-area-light',
                    standalone: true,
                    template: '<ng-content></ng-content>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [provideNgtCommonLight(NgtRectAreaLight), provideCommonLightRef(NgtRectAreaLight)],
                }]
        }], propDecorators: { width: [{
                type: Input
            }], height: [{
                type: Input
            }], power: [{
                type: Input
            }] } });
class NgtRectAreaLightModule {
}
NgtRectAreaLightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtRectAreaLightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtRectAreaLightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtRectAreaLightModule, imports: [NgtRectAreaLight], exports: [NgtRectAreaLight] });
NgtRectAreaLightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtRectAreaLightModule, imports: [NgtRectAreaLight] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtRectAreaLightModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtRectAreaLight],
                    exports: [NgtRectAreaLight],
                }]
        }] });

class NgtSpotLightPassThrough {
    constructor(host) {
        this.host = host;
        if (!host)
            return;
    }
    set ngtSpotLightPassThrough(wrapper) {
        NgtSpotLightPassThrough.assertWrapper(wrapper);
        const passThroughInput = createPassThroughInput(wrapper, this.host);
        passThroughInput('distance', true, true);
        passThroughInput('angle', true, true);
        passThroughInput('penumbra', true, true);
        passThroughInput('decay', true, true);
        passThroughInput('target', true, true);
        passThroughInput('power', true, true);
    }
    static assertWrapper(wrapper) {
        if (!wrapper || !(wrapper instanceof NgtSpotLight)) {
            throw new Error('ngtSpotLightPassThrough wrapper is not a NgtSpotLight');
        }
    }
}
NgtSpotLightPassThrough.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightPassThrough, deps: [{ token: NgtSpotLight, optional: true, self: true }], target: i0.ɵɵFactoryTarget.Directive });
NgtSpotLightPassThrough.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.1.0", type: NgtSpotLightPassThrough, isStandalone: true, selector: "[ngtSpotLightPassThrough]", inputs: { ngtSpotLightPassThrough: "ngtSpotLightPassThrough" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightPassThrough, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngtSpotLightPassThrough]',
                    standalone: true,
                }]
        }], ctorParameters: function () { return [{ type: NgtSpotLight, decorators: [{
                    type: Self
                }, {
                    type: Optional
                }] }]; }, propDecorators: { ngtSpotLightPassThrough: [{
                type: Input
            }] } });
class NgtSpotLightPassThroughModule {
}
NgtSpotLightPassThroughModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightPassThroughModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgtSpotLightPassThroughModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightPassThroughModule, imports: [NgtSpotLightPassThrough], exports: [NgtSpotLightPassThrough] });
NgtSpotLightPassThroughModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightPassThroughModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: NgtSpotLightPassThroughModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [NgtSpotLightPassThrough],
                    exports: [NgtSpotLightPassThrough],
                }]
        }] });

//GENERATED

/**
 * Generated bundle index. Do not edit.
 */

export { NgtAmbientLight, NgtAmbientLightModule, NgtAmbientLightProbe, NgtAmbientLightProbeModule, NgtDirectionalLight, NgtDirectionalLightModule, NgtHemisphereLight, NgtHemisphereLightModule, NgtHemisphereLightProbe, NgtHemisphereLightProbeModule, NgtLightProbe, NgtLightProbeModule, NgtPointLight, NgtPointLightModule, NgtRectAreaLight, NgtRectAreaLightModule, NgtSpotLight, NgtSpotLightModule, NgtSpotLightPassThrough, NgtSpotLightPassThroughModule };
//# sourceMappingURL=angular-three-core-lights.mjs.map
