import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import * as THREE from 'three';
import { NgtComponentStore } from './stores/component-store';
import type { BooleanInput, NgtCameraOptions, NgtDpr, NgtGLOptions, NgtSceneOptions, NgtState, NgtVector3 } from './types';
import * as i0 from "@angular/core";
export declare class NgtCanvas extends NgtComponentStore implements OnInit {
    hostClass: boolean;
    set linear(linear: BooleanInput);
    set legacy(legacy: BooleanInput);
    set flat(flat: BooleanInput);
    set frameloop(frameloop: 'always' | 'demand' | 'never');
    set orthographic(orthographic: BooleanInput);
    set dpr(dpr: NgtDpr);
    set raycaster(raycaster: Partial<THREE.Raycaster>);
    set shadows(shadows: BooleanInput | Partial<THREE.WebGLShadowMap>);
    set camera(cameraOptions: NgtCameraOptions);
    get cameraRef(): import("@angular-three/core").Ref<import("./types").NgtCamera & {
        manual?: boolean | undefined;
    }>;
    set lookAt(lookAt: NgtVector3);
    set scene(sceneOptions: NgtSceneOptions);
    get sceneRef(): import("@angular-three/core").Ref<THREE.Scene>;
    set gl(glOptions: NgtGLOptions);
    private _initialLog;
    get initialLog(): boolean;
    set initialLog(value: BooleanInput);
    private _projectContent;
    get projectContent(): boolean;
    set projectContent(value: BooleanInput);
    created: EventEmitter<NgtState>;
    pointermissed: EventEmitter<MouseEvent>;
    rendererCanvas: ElementRef<HTMLCanvasElement>;
    private zone;
    private store;
    private loader;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCanvas, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtCanvas, "ngt-canvas", never, { "linear": "linear"; "legacy": "legacy"; "flat": "flat"; "frameloop": "frameloop"; "orthographic": "orthographic"; "dpr": "dpr"; "raycaster": "raycaster"; "shadows": "shadows"; "camera": "camera"; "lookAt": "lookAt"; "scene": "scene"; "gl": "gl"; "initialLog": "initialLog"; "projectContent": "projectContent"; }, { "created": "created"; "pointermissed": "pointermissed"; }, never, ["*"], true>;
}
export declare class NgtCanvasModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCanvasModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtCanvasModule, never, [typeof NgtCanvas], [typeof NgtCanvas]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtCanvasModule>;
}
