import * as THREE from 'three';
import type { NgtObjectPropsState } from '../abstracts/object';
import { NgtObject } from '../abstracts/object';
import type { AnyConstructor } from '../types';
import * as i0 from "@angular/core";
export interface NgtCommonSpriteState<TSprite extends THREE.Sprite = THREE.Sprite> extends NgtObjectPropsState<TSprite> {
    material?: THREE.SpriteMaterial;
}
export declare abstract class NgtCommonSprite<TSprite extends THREE.Sprite = THREE.Sprite> extends NgtObject<TSprite, NgtCommonSpriteState<TSprite>> {
    set args(v: ConstructorParameters<AnyConstructor<TSprite>>);
    set material(material: THREE.SpriteMaterial);
    abstract get spriteType(): AnyConstructor<TSprite>;
    protected objectInitFn(): TSprite;
    protected get optionFields(): Record<string, boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCommonSprite<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtCommonSprite<any>, never, never, { "args": "args"; "material": "material"; }, {}, never, never, false>;
}
export declare const provideNgtCommonSprite: (sub: import("../types").AnyCtor<any>) => any[];
