import { InjectionToken, InjectOptions, Provider } from '@angular/core';
import { Ref } from '../ref';
import type { AnyCtor, AnyFunction } from '../types';
export declare function createNgtProvider(base: AnyCtor, ...providers: AnyFunction[]): (sub: AnyCtor) => any[];
export declare function createInjection<TTokenValue, TProvideValue = TTokenValue extends object ? Partial<TTokenValue> : TTokenValue>(description: string, { defaultValueOrFactory, provideValueFactory, }?: {
    defaultValueOrFactory?: TTokenValue | (() => TTokenValue);
    provideValueFactory?: (value: TProvideValue) => TTokenValue;
}): [
    injectFn: (options?: InjectOptions) => TTokenValue,
    provideFn: (value: TProvideValue) => Provider,
    token: InjectionToken<TTokenValue>
];
export declare function createRefInjection<TInstanceType extends object = any, TCtor extends AnyCtor<TInstanceType> = AnyCtor<TInstanceType>>(description: string, hostOrProviderFactory?: AnyFunction<Provider> | true, ...providersFactory: AnyFunction<Provider>[]): [
    injectFn: (options?: InjectOptions) => AnyFunction<Ref<TInstanceType>>,
    providedFn: <TProvideCtor extends TCtor = TCtor>(sub: TProvideCtor, factory?: (instance: InstanceType<TProvideCtor>) => Ref) => Provider,
    token: InjectionToken<AnyFunction<Ref<TInstanceType>>>
];
