import { AnyConstructor, AnyFunction, BooleanInput, NgtCommonMesh, NgtInstance, NgtInstanceState, NgtMatrix4, NgtObject, NumberInput, Ref } from '@angular-three/core';
import * as THREE from 'three';
import * as i0 from "@angular/core";
export declare class NgtSkinnedMesh extends NgtCommonMesh<THREE.SkinnedMesh> {
    set skeleton(skeleton: THREE.Skeleton);
    set useVertexTexture(useVertexTexture: BooleanInput);
    set bindMatrix(bindMatrix: NgtMatrix4);
    set bindMatrixInverse(bindMatrixInverse: NgtMatrix4);
    set bindMode(bindMode: string);
    get meshType(): AnyConstructor<THREE.SkinnedMesh>;
    protected get argsKeys(): string[];
    protected get optionFields(): Record<string, boolean>;
    bind(skeleton: THREE.Skeleton): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkinnedMesh, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtSkinnedMesh, "ngt-skinned-mesh", never, { "skeleton": "skeleton"; "useVertexTexture": "useVertexTexture"; "bindMatrix": "bindMatrix"; "bindMatrixInverse": "bindMatrixInverse"; "bindMode": "bindMode"; }, {}, never, ["*"], true>;
}
export interface NgtSkeletonState extends NgtInstanceState<THREE.Skeleton> {
    bones: THREE.Bone[];
    boneInverses: THREE.Matrix4[];
    boneMatrices: Float32Array;
    boneTexture: null | THREE.DataTexture;
    boneTextureSize: number;
    frame: number;
}
export declare class NgtSkeleton extends NgtInstance<THREE.Skeleton, NgtSkeletonState> {
    set args(args: ConstructorParameters<typeof THREE.Skeleton>);
    set bones(bones: THREE.Bone[]);
    set boneInverses(boneInverses: NgtMatrix4[]);
    set boneMatrices(boneMatrices: Float32Array);
    set boneTexture(boneTexture: null | THREE.DataTexture);
    set boneTextureSize(boneTextureSize: NumberInput);
    set frame(frame: NumberInput);
    private skinnedMesh;
    protected parentRef: AnyFunction<Ref<any>>;
    protected parentHostRef: AnyFunction<Ref<any>>;
    constructor();
    protected preInit(): void;
    ngOnInit(): void;
    private readonly init;
    protected get optionFields(): Record<string, boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkeleton, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtSkeleton, "ngt-skeleton", never, { "args": "args"; "bones": "bones"; "boneInverses": "boneInverses"; "boneMatrices": "boneMatrices"; "boneTexture": "boneTexture"; "boneTextureSize": "boneTextureSize"; "frame": "frame"; }, {}, never, ["*"], true>;
}
export declare class NgtBone extends NgtObject<THREE.Bone> {
    private hostBoneRef;
    private hostSkeletonRef;
    private hostSkinnedMeshRef;
    private parentBone;
    private parentSkinnedMesh;
    private parentSkeleton;
    protected parentRef: AnyFunction<Ref<any>>;
    protected parentHostRef: AnyFunction<Ref<any>>;
    protected objectInitFn(): THREE.Bone;
    protected postPrepare(bone: THREE.Bone): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtBone, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtBone, "ngt-bone", never, {}, {}, never, ["*"], true>;
}
export declare class NgtSkinnedMeshModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtSkinnedMeshModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtSkinnedMeshModule, never, [typeof NgtSkinnedMesh, typeof NgtSkeleton, typeof NgtBone], [typeof NgtSkinnedMesh, typeof NgtSkeleton, typeof NgtBone]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtSkinnedMeshModule>;
}
